/** @return {timerController} */
const getTimerController = ()=>self
var timerController = JSB.defineClass('timerController : UIViewController <UIWebViewDelegate>',{
  // /** @self {timerController} */
  viewDidLoad: function() {
  try {
    
    let self = getTimerController()
    self.appInstance = Application.sharedInstance();
    self.custom = false;
    self.customMode = "None"
    self.miniMode = false;
    self.shouldCopy = false
    self.shouldComment = false
    self.selectedText = '';
    self.searchedText = '';
    self.webApp = "Bilibili"
    self.isFirst = true
    self.timerOn = false
    if (!(self.webApp in timerConfig.webAppEntries)) {
      self.webApp = timerConfig.webAppEntrieNames[0]
    }
    self.isLoading = false;
    self.view.frame = {x:50,y:50,width:(self.appInstance.osType !== 1) ? 419 : 365,height:450}
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.isMainWindow = true
    self.title = "main"
    self.test = [0]
    self.moveDate = Date.now()
    self.color = [true,true,true,true,true,true,true,true,true,true,true,true,true,true,true,true]
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = MNUtil.hexColorAlpha("#636363",0.5)
    self.view.layer.cornerRadius = 15
    self.view.layer.opacity = 1.0
    self.view.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
    self.view.layer.borderWidth = 0

    // >>> DeepL view >>>
    self.webview = new UIWebView(self.view.bounds);
    self.webview.backgroundColor = UIColor.whiteColor();
    self.webview.scalesPageToFit = true;
    self.webview.autoresizingMask = (1 << 1 | 1 << 4);
    self.webview.delegate = self;
    self.webview.scrollView.delegate = self;
    self.webview.layer.cornerRadius = 15;
    self.webview.layer.masksToBounds = true;
    self.webview.layer.borderColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
    self.webview.layer.borderWidth = 0
    self.highlightColor = UIColor.blendedColor( MNUtil.hexColorAlpha("#2c4d81",0.8),
      self.appInstance.defaultTextColor,
      0.8
    );

    self.webview.hidden = true;
    self.webview.lastOffset = 0;
    // self.view.addSubview(self.webview);
        // let dragInteraction = UIDragInteraction(self)
        // self.view.addInteraction(dragInteraction)
    self.createButton("toolbar")
    self.toolbar.backgroundColor = MNUtil.hexColorAlpha("#727f94",0.5)
    self.toolbar.hidden = true

    self.createButton("webAppButton","changeWebApp:","toolbar")
    // self.webAppButton.setTitleForState('📺', 0);
    self.webAppButton.setImageForState(timerUtils.webappImage,0)

    self.createButton("closeButton","closeButtonTapped:")
    self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(10);

    self.createButton("minButton","minButtonTapped:")
    self.minButton.setTitleForState('➖', 0);
    self.minButton.titleLabel.font = UIFont.systemFontOfSize(10);

    // self.createButton("screenButton","changeScreen:","toolbar")
    self.createButton("screenButton","changeOpacity:")

    self.screenButton.setImageForState(timerUtils.screenImage,0)
    MNButton.setColor(self.screenButton, "#ffffff",0.0)
    self.createButton("engineButton","changeEngine:","toolbar")
    self.engineButton.setTitleForState(timerConfig.entries[timerConfig.engine].engine, 0);
    self.engineButton.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.createButton("homeButton","homeButtonTapped:","toolbar")
    self.homeButton.setImageForState(timerUtils.homeImage,0)

    self.createButton("customButton1","customButtonTapped:","toolbar")
    self.customButton1.index = 1
    self.customButton1.setTitleForState(timerConfig.getCustomEmoji(1), 0);
    self.customButton1.titleLabel.font = UIFont.boldSystemFontOfSize(14);
    // self.customButton.setImageForState(timerUtils.homeImage,0)

    self.createButton("customButton2","customButtonTapped:","toolbar")
    self.customButton2.index = 2
    self.customButton2.setTitleForState(timerConfig.getCustomEmoji(2), 0);
    self.customButton2.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.createButton("customButton3","customButtonTapped:","toolbar")
    self.customButton3.index = 3
    self.customButton3.setTitleForState(timerConfig.getCustomEmoji(3), 0);
    self.customButton3.titleLabel.font = UIFont.boldSystemFontOfSize(14);

    self.createButton("moveButton","moveButtonTapped:")

    self.createButton("goForwardButton","goForwardButtonTapped:","toolbar")
    self.goForwardButton.setImageForState(timerUtils.goforwardImage,0)

    self.createButton("goBackButton","goBackButtonTapped:","toolbar")
    self.goBackButton.setImageForState(timerUtils.gobackImage,0)
    // <<< goBack button <<<
    // >>> refresh button >>>
    self.createButton("refreshButton","refreshButtonTapped:","toolbar")
    self.refreshButton.setImageForState(timerUtils.reloadImage,0)
    // <<< refresh button <<<

    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")

    self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    self.screenButton.addGestureRecognizer(self.resizeGesture)
    self.resizeGesture.view.hidden = false
    self.resizeGesture.addTargetAction(self,"onResizeGesture:")
    self.creatTextView("todoText")
    MNButton.setRadius(self.todoText,10)
  } catch (error) {
    timerUtils.addErrorLog(error, "viewDidLoad")
  }
  },
  viewWillAppear: function(animated) {
    self.webview.delegate = self;
  },
  viewWillDisappear: function(animated) {
    self.webview.stopLoading();
    self.webview.delegate = null;
    UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
  },

viewWillLayoutSubviews: function() {
  let self = getTimerController()
    var viewFrame = self.view.bounds;
    if (self.onAnimate) {
      return
    }
    if (self.miniMode) {
      let webFrame = MNUtil.genFrame(0, 0, viewFrame.width, 70)
      self.webview.frame = webFrame
      MNButton.setRadius(self.moveButton,15)
      return
    }
    MNButton.setRadius(self.moveButton,8)
    let buttonHeight = 25
    var width    = viewFrame.width
    var height   = viewFrame.height
    self.closeButton.frame = MNUtil.genFrame(width-18,0,18,18)
    self.minButton.frame = MNUtil.genFrame(width-43,0,18,18)
    self.toolbar.frame = MNUtil.genFrame(1,height-30,width-2,buttonHeight)
    self.screenButton.frame = MNUtil.genFrame(width-20,height-20,20,20)
    self.todoText.frame = MNUtil.genFrame(width*0.5-100,height-40,200,35)
    self.engineButton.frame = {x: width - 122,y: 0,width: 75,height: buttonHeight};

    if (width <= 300) {
      self.goBackButton.hidden = true
      self.goForwardButton.hidden = true
      self.refreshButton.hidden = true
      self.moveButton.frame = {x: width*0.5-75,y: 0,width: width*0.35,height: 16};
      self.homeButton.frame = {  x: 0,  y: 0,  width: 35,  height: buttonHeight,};    
      self.webAppButton.frame = {  x: 40,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton1.frame = {  x: 80,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton2.frame = {  x: 120,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton3.frame = {  x: 160,  y: 0,  width: 35,  height: buttonHeight,};
    }else if (width <= 380) {
      self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: width*0.35,  height: 16};
      self.refreshButton.hidden = !timerConfig.toolbar
      self.goBackButton.hidden = !timerConfig.toolbar
      self.homeButton.hidden = !timerConfig.toolbar
      self.goForwardButton.hidden = !timerConfig.toolbar
      self.engineButton.hidden = true
      self.homeButton.frame = {  x: 106,  y: 0,  width: 35,  height: buttonHeight,};  
      self.webAppButton.frame = {  x: 146,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton1.frame = {  x: 186,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton2.frame = {  x: 226,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton3.frame = {  x: 266,  y: 0,  width: 35,  height: buttonHeight,};
    }else{
      self.customButton2.hidden = width < 435
      self.customButton3.hidden = width < 475
      self.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 16};
      self.refreshButton.hidden = !timerConfig.toolbar
      self.goBackButton.hidden = !timerConfig.toolbar
      self.goForwardButton.hidden = !timerConfig.toolbar
      self.engineButton.hidden = !timerConfig.toolbar
      self.homeButton.hidden = !timerConfig.toolbar
      self.webAppButton.hidden = !timerConfig.toolbar
      self.screenButton.hidden = false
      self.homeButton.frame = {  x: 106,  y: 0,  width:35,  height: buttonHeight,};   
      self.webAppButton.frame = {  x: 146,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton1.frame = {  x: 186,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton2.frame = {  x: 226,  y: 0,  width: 35,  height: buttonHeight,};
      self.customButton3.frame = {  x: 266,  y: 0,  width: 35,  height: buttonHeight,};
    }

    self.goBackButton.frame = {  x:1,  y: 0,  width: 30,  height: buttonHeight,};
    self.goForwardButton.frame = {  x:36,  y: 0,  width: 30,  height: buttonHeight,};
    self.refreshButton.frame = {  x: 71,  y: 0,  width: 30,  height: buttonHeight,};
    self.customButton1.hidden = true
    self.customButton2.hidden = true
    self.customButton3.hidden = true
    self.webview.frame = {x:0,y:8,width:width,height:height-8}
    try {
      if (self.settingView) {
        self.settingViewLayout()
        self.refreshLayout()
      }
    } catch (error) {
      timerUtils.addErrorLog(error, "viewWillLayoutSubviews")
    }

  },

  webViewDidStartLoad: function(webView) {
  },
  webViewDidFinishLoad: function(webView) {
  },
  webViewDidFailLoadWithError: function(webView, error) {
    // MNUtil.showHUD("789")
    // self.screenButton.setTitleForState('Screen', 0);
    self.refreshButton.setImageForState(timerUtils.reloadImage,0)
    // self.refreshButton.setTitleForState('🔄', 0);
    self.changeButtonOpacity(1.0)
    self.isLoading = false;
    // MNUtil.showHUD(error)
    // let errorInfo = {
    //   code:error.code,
    //   domain: error.domain,
    //   description: error.localizedDescription,
    //   userInfo: error.userInfo
    // }
    // MNUtil.copyJSON(errorInfo)

    // self.getCurrentURL()
    //UIApplication.sharedApplication().networkActivityIndicatorVisible = false;
    //var lan = NSLocale.preferredLanguages() ? NSLocale.preferredLanguages()[0].substring(0,2) : 'en';
    //if (lan == 'zh') {
    //  Application.sharedInstance().showHUD('错误', self.view.window, 2);
    //} else {
    //  Application.sharedInstance().showHUD('Failed to load DeepL translator, please try again later', self.view.window, 2);
    //}
  },
  webViewShouldStartLoadWithRequestNavigationType: function(webView,request,type){
    let currentURL = webView.request.URL().absoluteString()
    // MNUtil.copy(currentURL)
    let requestURL = request.URL().absoluteString()
    if (/^timer\:\/\//.test(requestURL)) {
      let text = decodeURIComponent(requestURL.split("action=")[1])
      switch (text) {
        case "beginTimer":
          self.miniMode = true
          let frame = self.view.frame
          let viewCenter = self.view.center.x
          frame.x = viewCenter-100
          frame.width = 200
          frame.height = 70
          self.toMinimode(frame)
          break;
        case "openSetting":
          self.webview.endEditing(true)
          break;
        default:
          break;
      }
      return false
    }
    // Application.sharedInstance().showHUD(requestURL, self.view.window, 2);
    if (/^https:\/\/d.bilibili/.test(requestURL)) {
      return false
    }
    if (/^(marginnote\dapp|zotero)/.test(requestURL)) {
      MNUtil.openURL(requestURL)
      // Application.sharedInstance().openURL(NSURL.URLWithString(requestURL));
      return false
    }
    if (timerUtils.shouldPrevent(currentURL,requestURL,type)) {
      // MNUtil.showHUD("prevent")
      MNConnection.loadRequest(self.webview, requestURL)
      return false
    }
    return true;
  },
  /**
   * 
   * @param {UITextView} textview 
   */
  textViewDidChange:function (textview) {
    let text = textview.text
    if (/\n/.test(text) && text.trim()) {
      textview.text = text.trim()
      textview.endEditing(true)
    }
  },
  changeScreen: function(sender) {
    if (sender.link) {
      MNConnection.loadRequest(self.webview, sender.link)
      return
    }
    var commandTable 
    if (self.isMainWindow) {
      commandTable = [
        {title:'🎚 Zoom',object:self,selector:'changeZoom:',param:sender},
      ];
    }else{
      commandTable = [
        {title:'🎚 Zoom',object:self,selector:'changeZoom:',param:sender},
        {title:'🫧 Opacity',object:self,selector:'changeOpacity:',param:sender}
      ];
    }
    
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,250,2)
  },
  moveButtonTapped: function(button) {
    if (self.miniMode) {
      // if (button.clickDate && (Date.now() - button.clickDate < 500)) {
        //双击
        let viewFrame = self.view.frame
        let preFrame = viewFrame
        self.view.hidden = true
        self.showAllButton()
        self.setFrame(self.lastFrame)
        self.show(preFrame)
      // }else{
      //   button.clickDate = Date.now()
      //   self.pause()
      // }

      return
    }
    timerConfig.dynamic = false;
    self.miniMode = true
    let frame = self.view.frame
    let studyFrame = MNUtil.studyView.bounds
    let studyCenter = MNUtil.studyView.center.x
    let viewCenter = self.view.center.x
    frame.x = viewCenter-100
    frame.width = 200
    frame.height = 70
    self.toMinimode(frame)
    return
    var commandTable 
    if (self.isMainWindow) {
      commandTable = [
        {title:'🌗 Left',object:self,selector:'splitScreen:',param:'left',checked:self.customMode==="left"},
        {title:'🌘 Left 1/3',object:self,selector:'splitScreen:',param:'left13',checked:self.customMode==="left13"},
        {title:'🌓 Right',object:self,selector:'splitScreen:',param:'right',checked:self.customMode==="right"},
        {title:'🌒 Right 1/3',object:self,selector:'splitScreen:',param:'right13',checked:self.customMode==="right13"},
        {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:timerConfig.dynamic},
        {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:timerConfig.toolbar},
        {title:'➕ Open in new window',object:self,selector:'openInNewWindow:',param:self.webview.url},
        {title:'➕ Open new window',object:self,selector:'openNewWindow:',param:timerConfig.getConfig("homePage").url},
        {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
        {title:'⏲ Timer',object:self,selector:'openTimer:',param:'right'},
        {title:'🎬 Screenshot',object:self,selector:'screenshot:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → Clipboard',object:self,selector:'videoFrame:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → Editor',object:self,selector:'videoFrameToEditor:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → CurrentNote',object:self,selector:'videoFrameToNote:',param:false},
        {title:'🎬 VideoFrame → ChildNote',object:self,selector:'videoFrameToNote:',param:true},
        {title:'🎬 VideoFrame → NewNote',object:self,selector:'videoFrameToNewNote:',param:true},
        {title:'🎬 VideoFrame → NewComment',object:self,selector:'videoFrameToComment:',param:true},
      ];
    }else{
      commandTable = [
        {title:'🌗 Left',object:self,selector:'splitScreen:',param:'left',checked:self.customMode==="left"},
        {title:'🌘 Left 1/3',object:self,selector:'splitScreen:',param:'left13',checked:self.customMode==="left13"},
        {title:'🌓 Right',object:self,selector:'splitScreen:',param:'right',checked:self.customMode==="right"},
        {title:'🌒 Right 1/3',object:self,selector:'splitScreen:',param:'right13',checked:self.customMode==="right13"},
        {title:'🌟 Dynamic',object:self,selector:'dynamicButtonTapped:',param:'right',checked:timerConfig.dynamic},
        {title:'🌟 Toolbar',object:self,selector:'toggleToolbar:',param:'right',checked:timerConfig.toolbar},
        {title:'🌐 Open in browser',object:self,selector:'openInBrowser:',param:'right'},
        {title:'⏲ Timer',object:self,selector:'openTimer:',param:'right'},
        {title:'🎬 Screenshot',object:self,selector:'screenshot:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → Clipboard',object:self,selector:'videoFrame:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → Editor',object:self,selector:'videoFrameToEditor:',param:self.view.frame.width>1000?self.view.frame.width:1000},
        {title:'🎬 VideoFrame → CurrentNote',object:self,selector:'videoFrameToNote:',param:false},
        {title:'🎬 VideoFrame → ChildNote',object:self,selector:'videoFrameToNote:',param:true},
        {title:'🎬 VideoFrame → NewNote',object:self,selector:'videoFrameToNewNote:',param:true},
        {title:'🎬 VideoFrame → NewComment',object:self,selector:'videoFrameToComment:',param:true},
      ];
    }
    self.view.popoverController = MNUtil.getPopoverAndPresent(button, commandTable,250,1)
  },
  changeEngine: function(sender) {

    // if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // var menuController = MenuController.new();
    var commandTable = timerConfig.entrieNames.map(entrieName => {
      return {title:timerConfig.entries[entrieName].title,object:self,selector:'searchWithEngine:',param:entrieName,checked:timerConfig.engine===entrieName}
    }).concat(
      {title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"engine", checked:timerConfig.entries[timerConfig.engine].desktop}
    )
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,200,4)
  },
  changeWebApp: function(sender) {
    var commandTable = timerConfig.webAppEntrieNames.map(entrieName => {
      return {title:timerConfig.webAppEntries[entrieName].title,object:self,selector:'changeWebAppTo:',param:entrieName,checked:self.webApp === entrieName}
    })
    .concat([
      {title:'🖥️ Desktop mode',object:self,selector:'toggleDesktop:',param:"webApp", checked:timerConfig.webAppEntries[self.webApp].desktop},
      {title:'➕ Add this page',object:self,selector:'addPageToWebApp:',param:'123'}
    ])
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,200)
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,100)
  },
  changeZoom: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var commandTable = [
      {title:'175%',object:self,selector:'changeZoomTo:',param:1.75},
      {title:'150%',object:self,selector:'changeZoomTo:',param:1.5},
      {title:'125%',object:self,selector:'changeZoomTo:',param:1.25},
      {title:'100%',object:self,selector:'changeZoomTo:',param:1.0},
      {title:'75%', object:self,selector:'changeZoomTo:',param:0.75},
      {title:'50%', object:self,selector:'changeZoomTo:',param:0.5}
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,100)
  },
  changeSearchOrder: function(sender) {
    var commandTable = [
      {title:'Title → Excerpt → Comment',object:self,selector:'setSearchOrder:',param:[1,2,3],checked:timerConfig.searchOrder==[1,2,3]},
      {title:'Title → Comment → Excerpt',object:self,selector:'setSearchOrder:',param:[1,3,2],checked:timerConfig.searchOrder==[1,3,2]},
      {title:'Excerpt → Title → Comment',object:self,selector:'setSearchOrder:',param:[2,1,3],checked:timerConfig.searchOrder==[2,1,3]},
      {title:'Excerpt → Comment → Title',object:self,selector:'setSearchOrder:',param:[2,3,1],checked:timerConfig.searchOrder==[2,3,1]},
      {title:'Comment → Title → Excerpt',object:self,selector:'setSearchOrder:',param:[3,1,2],checked:timerConfig.searchOrder==[3,1,2]},
      {title:'Comment → Excerpt → Title',object:self,selector:'setSearchOrder:',param:[3,2,1],checked:timerConfig.searchOrder==[3,2,1]},
    ];
    self.view.popoverController = MNUtil.getPopoverAndPresent(sender, commandTable,300)
  },
  changeCustomButton: function(button){
    if (timerUtils.checkSubscribe(false)) {
      let actions = ["openNewWindow","openInNewWindow","screenshot","videoFrame2Clipboard","videoFrame2Editor","videoFrame2Note","videoFrame2ChildNote","videoFrameToNewNote","videoFrameToComment","pauseOrPlay","forward10s","backward10s","bigbang","copyCurrentURL","copyAsMDLink","openCopiedURL"]
      var commandTable = actions.map(action=>{
        return {title:action,object:self,selector:'setCustomAction:',param:{index:button.index,action:action}}
      })
      self.view.popoverController = MNUtil.getPopoverAndPresent(button, commandTable,300,1)
    }
  },
  setCustomAction: function(config){
    if (timerUtils.checkSubscribe(true)) {
      if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
      if (config.index === 1) {
        timerConfig.config.custom = config.action
        self["setCustomButton"+config.index].setTitleForState("Custom"+config.index+": "+timerConfig.getConfig("custom"),0)
      }else{
        timerConfig.config["custom"+config.index] = config.action
        self["setCustomButton"+config.index].setTitleForState("Custom"+config.index+": "+timerConfig.getConfig("custom"+config.index),0)
      }
      timerConfig.save("MNTimer_config")
      self["customButton"+config.index].setTitleForState(timerConfig.getCustomEmoji(config.index))
    }
  },
  toggleTimestampeDetail: function (params) {
    let timestampDetail = !timerConfig.getConfig("timestampDetail")
    timerConfig.config.timestampDetail = timestampDetail
    self.timestampDetail.setTitleForState("Timestamp Detail: "+(timestampDetail?"✅":"❌"),0)
    timerConfig.save("MNTimer_config")
  },
  setSearchOrder:function (order) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    timerConfig.searchOrder = order
    self.orderButton.setTitleForState(timerUtils.getOrderText(timerConfig.searchOrder),0)
    timerConfig.save("MNTimer_searchOrder")
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
  },
  changeZoomTo:function (zoom) {
    self.runJavaScript(`document.body.style.zoom = ${zoom}`)
  },
  openSettingView:function () {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.settingController.view.hidden = false
    if (!self.settingView) {
      self.createSettingView()
    }
    self.settingView.hidden = false
    let frame = self.view.frame
    if (frame.height < 420) {
      frame.height = 420
    }
    self.view.frame = frame
    self.currentFrame = frame
    
    try {
      self.refreshView("configView")
    } catch (error) {
      timerUtils.addErrorLog(error, "openSettingView")
    }




    // self.view.addSubview(self.tabView)
  },
  toggleToolbar:function (opacity) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
try {
  

    timerConfig.toolbar = !timerConfig.toolbar
    self.webAppButton.hidden = !timerConfig.toolbar
    self.homeButton.hidden = !timerConfig.toolbar
    self.goBackButton.hidden = !timerConfig.toolbar
    self.goForwardButton.hidden = !timerConfig.toolbar
    self.refreshButton.hidden = !timerConfig.toolbar
    self.engineButton.hidden = !timerConfig.toolbar
    self.customButton1.hidden = !timerConfig.toolbar
    self.customButton2.hidden = !timerConfig.toolbar
    // MNUtil.showHUD("message"+self.customButton1.hidden+":"+!timerConfig.toolbar)
    self.customButton3.hidden = !timerConfig.toolbar
} catch (error) {
  timerUtils.addErrorLog(error, "toggleToolbar")
}
    var viewFrame = self.view.bounds;
    MNUtil.animate(()=>{
      if (timerConfig.toolbar) {
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height-40}
      }else{
        self.webview.frame = {x:viewFrame.x+1,y:viewFrame.y+10,width:viewFrame.width-2,height:viewFrame.height}
      }
    })
    timerConfig.save("MNTimer_toolbar")
  },
  toggleDesktop:function (param) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    let desktop
    switch (param) {
      case "engine":
        timerConfig.entries[timerConfig.engine].desktop = !timerConfig.entries[timerConfig.engine].desktop
        desktop = timerConfig.entries[timerConfig.engine].desktop;
        timerConfig.save("MNTimer_entries")
        break;
      case "webApp":
        timerConfig.webAppEntries[self.webApp].desktop = !timerConfig.webAppEntries[self.webApp].desktop
        desktop = timerConfig.webAppEntries[self.webApp].desktop;
        timerConfig.save("MNTimer_webAppEntries")
        break;
      default:
        break;
    }
    if (desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
      if (param === "engine" && timerConfig.engine === "Baidu") {
        let newURL = self.webview.url.replace("m.baidu","www.baidu")
        MNConnection.loadRequest(self.webview, newURL)
        return;
      }
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
      
      if (param === "engine" && timerConfig.engine === "Baidu") {
        let newURL = self.webview.url.replace("www.baidu","m.baidu")
        MNConnection.loadRequest(self.webview, newURL)
        return;
      }
    }

    self.webview.reload();
  },
  searchWithEngine: function (engine) {
    timerConfig.engine = engine
    timerConfig.save("MNTimer_engine")
    if (self.selectedText.length) {
      self.search(self.selectedText) 
    }else{
      self.search(self.searchedText)//用户可能只是想换个搜索引擎再次搜索
    }
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
  },
  openInNewWindow: function (url) {
    self.checkPopover()
    if (timerUtils.checkSubscribe()) {
      let agent = self.webview.customUserAgent
      MNUtil.postNotification('newWindow', {url:url,desktop:timerConfig.entries[timerConfig.engine].desktop,engine:timerConfig.engine,webApp:self.webApp,agent:agent})
      self.homePage();
    }
  },
  openNewWindow: function (url) {
    self.checkPopover()
    if (timerUtils.checkSubscribe()) {
      MNUtil.postNotification('newWindow', {url:timerConfig.getConfig("homePage").url,desktop:timerConfig.entries[timerConfig.engine].desktop,engine:timerConfig.engine,webApp:self.webApp})
    }
  },
  openInBrowser: function (engine) {
  self.webview.evaluateJavaScript(
    `window.location.href`,
    (ret) => {
      self.webview.url = ret
      MNUtil.openURL(self.webview.url)
    }
  );
  },
  openTimer: function (params) {
    self.checkPopover()
    self.webview.loadFileURLAllowingReadAccessToURL(
      NSURL.fileURLWithPath(timerUtils.mainPath + '/timer.html'),
      NSURL.fileURLWithPath(timerUtils.mainPath + '/')
    );
  },
  copyCurrentURL: async function (engine) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    MNUtil.copy(url)
    MNUtil.showHUD("链接已复制")
  },
  copyCurrentURLWithText: async function(){
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    let text = await self.getSelectedTextInWebview()
    MNUtil.copy(`[${text}](${url})`)
    MNUtil.showHUD("链接已复制")
  },
  bigbang: async function(){
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let url = await self.getCurrentURL()
    let text = await self.getTextInWebview()
    MNUtil.postNotification('bigbangText', {text:text,url:url})
  },
  openCopiedURL: function (engine) {
    MNConnection.loadRequest(self.webview, MNUtil.clipboardText)
  },
  resetConfig: async function (engine) {
    let confirm = await MNUtil.confirm("Reset config?", "重置配置？")
    if (!confirm) {
      return
    }
    if (self.configMode===0) {
      timerConfig.entries = timerConfig.defaultEntries
      MNUtil.copyJSON(timerConfig.defaultEntries)
      timerConfig.entrieNames = Object.keys(timerConfig.entries)
      timerConfig.engine = timerConfig.entrieNames[0]
      self.engineButton.setTitleForState(timerConfig.entries[timerConfig.engine].engine, 0);
      self.setButtonText(timerConfig.entrieNames,timerConfig.engine)
      self.refreshLayout()
      self.setTextview(timerConfig.engine)
      timerConfig.remove("MNTimer_entrieNames")
      timerConfig.remove("MNTimer_entries")
      timerConfig.remove("MNTimer_engine")
    }else{
      timerConfig.webAppEntries = timerConfig.defaultWebAppEntries
      timerConfig.webAppEntrieNames = Object.keys(timerConfig.webAppEntries)
      self.webApp = timerConfig.webAppEntrieNames[0]
      self.setButtonText(timerConfig.webAppEntrieNames,self.webApp)
      self.refreshLayout()
      self.setTextview(self.webApp)
      timerConfig.remove("MNTimer_webAppEntrieNames")
      timerConfig.remove("MNTimer_webAppEntries")
      timerConfig.remove("MNTimer_webApp")
    }
  },
  uploadConfig: function (engine) {

    let note = MNUtil.getNoteById(self.currentNoteId)
    let customEntries
    let commentsLength = note.comments.length
    if (commentsLength === 0) {
      Application.sharedInstance().showHUD("No comments found",self.view.window,2)
      return;
    }
    try {
      let comment = note.comments[0].text.replaceAll(`”`,`"`).replaceAll(`“`,`"`)
      customEntries = JSON.parse(comment)
      if (!Object.keys(customEntries).length) {
        Application.sharedInstance().showHUD("Invalid config",self.view.window,2)
        return;
      }
      // Application.sharedInstance().showHUD(Object.keys(customEntries).length,self.view.window,2)
    } catch (error) {
      timerUtils.addErrorLog(error, "uploadConfig")
      return;
    }
    let uploadLog = [];
    if (customEntries.Search) {
      uploadLog.push(`"Search"`)
      timerConfig.entries = customEntries.Search
      timerConfig.entrieNames = Object.keys(timerConfig.entries)
      timerConfig.engine = timerConfig.entrieNames[0]
      self.engineButton.setTitleForState(timerConfig.entries[timerConfig.engine].engine, 0);
      timerConfig.save("MNTimer_entrieNames")
      timerConfig.save("MNTimer_entries")
      timerConfig.save("MNTimer_engine")
    }
    if (customEntries.WebApp) {
      uploadLog.push(`"WebApp"`)
      timerConfig.webAppEntries = customEntries.WebApp
      timerConfig.webAppEntrieNames = Object.keys(timerConfig.webAppEntries)
      self.webApp = timerConfig.webAppEntrieNames[0]
      timerConfig.save("MNTimer_webAppEntrieNames")
      timerConfig.save("MNTimer_webAppEntries")
    }
    if (uploadLog.length) {
      MNUtil.showHUD("Upload config of "+uploadLog.join(" and ")+" success!")
    }else{
      MNUtil.showHUD('Entries of "Search" or "WebApp" not found')
    }
  },
  screenshot: async function (width) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    let imageData = await self.screenshot(width)
    MNUtil.copyImage(imageData)
    MNUtil.showHUD('截图已复制到剪贴板')

    // self.webview.takeSnapshotWithWidth(width,(snapshot)=>{
    //   MNUtil.copyImage(snapshot.pngData())
    //   MNUtil.showHUD('截图已复制到剪贴板')
    // })
  },
  videoFrame: async function (width) {
    let self = getTimerController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.videoFrameAction("clipboard")
  },
  videoFrameToEditor: async function (width) {
    let self = getTimerController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.videoFrameAction("editor")
  },
  videoFrameToNote: async function (childNote) {
    let self = getTimerController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (childNote) {
      self.videoFrameAction("childNote")
    }else{
      self.videoFrameAction("excerpt")
    }
  },
  videoFrameToNewNote: async function (childNote) {
    let self = getTimerController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.videoFrameAction("newNote")
  },
  videoFrameToComment: async function () {
      let self = getTimerController()
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.videoFrameAction("comment")
  },
  homeButtonTapped: function() {
    self.homePage()
  },
  customButtonTapped: async function(button){
    let self = getTimerController()
    if (!timerUtils.checkSubscribe(true)) {
      return
    }
    let url
    let text
    let configName = (button.index === 1)?"custom":"custom"+button.index
    switch (timerConfig.getConfig(configName)) {
      case "screenshot":
        self.webview.takeSnapshotWithWidth(width,(snapshot)=>{
          MNUtil.copyImage(snapshot.pngData())
          MNUtil.showHUD('截图已复制到剪贴板')
        })
        break;
      case "videoFrame2Clipboard":
        self.videoFrameAction("clipboard")
        break;
      case "videoFrame2Editor":
        self.videoFrameAction("editor")
        break;
      case "videoFrame2Note":
        self.videoFrameAction("excerpt")
        break;
      case "videoFrame2ChildNote":
        self.videoFrameAction("childNote")
        break;
      case "videoFrameToNewNote":
        self.videoFrameAction("newNote")
        break;
      case "videoFrameToComment":
        self.videoFrameAction("comment")
        break;
      case "bigbang":
        url = await self.getCurrentURL()
        text = await self.getTextInWebview()
        MNUtil.postNotification('bigbangText', {text:text,url:url})
        break;
      case "copyCurrentURL":
        url = await self.getCurrentURL()
        MNUtil.copy(url)
        MNUtil.showHUD("链接已复制")
        break;
      case "copyAsMDLink":
        url = await self.getCurrentURL()
        text = await self.getSelectedTextInWebview()
        MNUtil.copy(`[${text}](${url})`)
        MNUtil.showHUD("链接已复制")
        break;
      case "openInNewWindow":
        if (timerUtils.checkSubscribe()) {
          let agent = self.webview.customUserAgent
          url = await self.getCurrentURL()
          MNUtil.postNotification('newWindow', {url:url,desktop:timerConfig.entries[timerConfig.engine].desktop,engine:timerConfig.engine,webApp:self.webApp,agent:agent})
          self.homePage();
        }
        break;
      case "openNewWindow":
        if (timerUtils.checkSubscribe()) {
          MNUtil.postNotification('newWindow', {url:timerConfig.getConfig("homePage").url,desktop:timerConfig.entries[timerConfig.engine].desktop,engine:timerConfig.engine,webApp:self.webApp})
        }
        break;
      case "openCopiedURL":
        MNConnection.loadRequest(self.webview, MNUtil.clipboardText)
        break;
      case "pauseOrPlay":
        // MNUtil.showHUD("pauseOrPlay")
        self.runJavaScript(`function togglePlayPause() {
    // 假设我们的video元素的id是'myVideo'
  const video = document.getElementsByTagName('video')[0];
    if (video.paused) {
        // 如果视频是暂停的，开始播放
        video.play();
    } else {
        // 如果视频正在播放，暂停它
        video.pause();
    }
};
togglePlayPause()
`)
        break;
      case "forward10s":
        // MNUtil.showHUD("⏩ Forward 10s")
        self.runJavaScript(` function forward10Seconds() {
const video = document.getElementsByTagName('video')[0];
video.currentTime += 10;
};
forward10Seconds()`);
        break;
      case "backward10s":
        // MNUtil.showHUD("⏪ Backward 10s")
        self.runJavaScript(` function backward10Seconds() {
const video = document.getElementsByTagName('video')[0];
video.currentTime -= 10;
};
backward10Seconds();`);
        break;
      default:
        break;
    }
  },
  goBackButtonTapped: function() {
    self.webview.goBack();
  },
  goForwardButtonTapped: function() {
    self.webview.goForward();
  },
  refreshButtonTapped: function(para) {
    if (self.webview.loading) {
      self.webview.stopLoading();
      self.refreshButton.setImageForState(timerUtils.reloadImage,0)
      self.changeButtonOpacity(1.0)
      self.isLoading = false;
    }else{
      self.webview.reload();
    }
  },
  dynamicButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    // self.switchView();
    timerConfig.dynamic = !timerConfig.dynamic;
    if (timerConfig.dynamic) {
      timerConfig.toolbar = false
      self.custom = false;
      self.customMode = "None"
      self.webAppButton.hidden = true
      self.homeButton.hidden = true
      self.goBackButton.hidden = true
      self.goForwardButton.hidden = true
      self.refreshButton.hidden = true
      self.engineButton.hidden = true
      self.customButton1.hidden = true
      self.customButton2.hidden = true
      self.customButton3.hidden = true
      var viewFrame = self.view.bounds;
      self.webview.frame = MNUtil.genFrame(viewFrame.x+1, viewFrame.y+10, viewFrame.width-2, viewFrame.height)
    }
    timerConfig.save("MNTimer_dynamic")
  },
  closeButtonTapped: async function() {
    let self = getTimerController()
    await self.hide()
    // self.homePage()
    self.webview.removeFromSuperview();
    // self.clearContent()
  },
 closeConfigTapped: function () {
  let preOpacity = self.settingView.layer.opacity
  UIView.animateWithDurationAnimationsCompletion(0.2,()=>{
    self.settingView.layer.opacity = 0
  },()=>{
    self.settingView.layer.opacity = preOpacity
    self.settingView.hidden = true
  })
 },
 splitScreen: function (mode) {
  if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
  self.lastFrame = self.view.frame
  self.custom = true;
  self.customMode = mode
  timerConfig.dynamic = false;
  self.webview.hidden = false
  self.hideAllButton()
  MNUtil.animate(()=>{
    self.setSplitScreenFrame(mode)
  },0.3).then(()=>{
    self.showAllButton()
  })
 },

  minButtonTapped: function() {
    self.miniMode = true
    let frame = self.view.frame
    let viewCenter = self.view.center.x
    frame.x = viewCenter-100
    frame.width = 200
    frame.height = 70
    self.toMinimode(frame)
  },
  onMoveGesture:function (gesture) {
    let location = timerUtils.getNewLoc(gesture)
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    // let studyFrame = MNUtil.studyView.bounds
    let studyFrame = MNUtil.currentWindow.bounds
    let y = location.y
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    if (self.miniMode) {
      if (x<0) {
        x = 0
      }
      if (x>=studyFrame.width-200) {
        x = studyFrame.width - 200
      }
      if (y>=studyFrame.height-70) {
        y = studyFrame.height-70
      }
    }else{
      if (y<=30) {
        y = 30
      }
    }
    
    self.setFrame(x, y, frame.width,frame.height)
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    timerConfig.dynamic = false;
    self.customMode = "none"
    let baseframe = gesture.view.frame
    let locationToBrowser = gesture.locationInView(self.view)
    let frame = self.view.frame
    let width = locationToBrowser.x+baseframe.width*0.35
    let height = locationToBrowser.y+baseframe.height*0.35
    if (width <= 215) {
      width = 215
    }
    if (height <= 100) {
      height = 100
    }
    if (self.settingView && !self.settingView.hidden) {
      if (height <= 420) {
        height = 420
      }
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.setFrame(frame.x, frame.y, width,height)
  },
  changeWebAppTo:function(webApp) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    if (webApp) {
      self.webApp = webApp;
    }
    var url;
    url = timerConfig.webAppEntries[self.webApp].link
    if (timerConfig.webAppEntries[self.webApp].desktop) {
      self.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    }else{
      self.webview.customUserAgent = 'Mozilla/5.0 (iPhone; CPU iPhone OS 15_0 like Mac OS X) AppleWebKit/605.1.15 (KHTML, like Gecko) Mobile/15E148'
    };
    if (self.webview.url !== url) {
      MNConnection.loadRequest(self.webview, url)
      self.webview.hidden = false
      return
    }
  },
  addPageToWebApp: async function (params) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    let url = await self.getCurrentURL()
    let config = {title:"test",desktop:false,link:url}
    let title = await self.runJavaScript("document.title")
    UIAlertView.showWithTitleMessageStyleCancelButtonTitleOtherButtonTitlesTapBlock(
      "Name for this page?",url,2,"Cancel",[title,"Add"],
      (alert, buttonIndex) => {
        switch (buttonIndex) {
          case 1:
            // self.appInstance.showHUD(title,self.view.window,2)
            config = {title:title,desktop:false,link:url}
            break;
          case 2:
            // self.appInstance.showHUD(alert.textFieldAtIndex(0).text,self.view.window,2)
            config = {title:alert.textFieldAtIndex(0).text,desktop:false,link:url}
            break;
          default:
            break;
        }
        let i = 0
        while (timerConfig.webAppEntries["customEWebApp"+i]) {
          i = i+1
        }
        timerConfig.webAppEntries["customEWebApp"+i] = config
        timerConfig.webAppEntrieNames = timerConfig.webAppEntrieNames.concat(("customEWebApp"+i))
        self.configEngine = "customEWebApp"+i
        timerConfig.save("MNTimer_webAppEntrieNames")
        timerConfig.save("MNTimer_webAppEntries")

      })
  },
  advancedButtonTapped: function (params) {
    self.configView.hidden = true
    self.advanceView.hidden = false
    self.syncView.hidden = true

    MNButton.setColor(self.advancedButton, "#457bd3")
    MNButton.setColor(self.configButton, "#9bb2d6")
    MNButton.setColor(self.syncConfig, "#9bb2d6")
  },
  syncConfigTapped: function (params) {
    self.configView.hidden = true
    self.advanceView.hidden = true
    self.syncView.hidden = false
    MNButton.setColor(self.advancedButton, "#9bb2d6")
    MNButton.setColor(self.configButton, "#9bb2d6")
    MNButton.setColor(self.syncConfig, "#457bd3")
    self.refreshView("syncView")
  },
  configButtonTapped: function (params) {
    self.configView.hidden = false
    self.advanceView.hidden = true
    self.syncView.hidden = true
    MNButton.setColor(self.advancedButton, "#9bb2d6")
    MNButton.setColor(self.configButton, "#457bd3")
    MNButton.setColor(self.syncConfig, "#9bb2d6")
    self.refreshView("configView")

  },
  exportConfig: async function (params) {
    let success = await timerConfig.export()
    if (success) {
      self.configNoteIdInput.text = timerConfig.getConfig("syncNoteId")
      timerConfig.save("MNTimer_config")
      MNUtil.showHUD("Export Success!")
      let dateObj = new Date(timerConfig.getConfig("lastSyncTime"))
      MNButton.setTitle(self.syncTimeButton, "Last Sync Time: "+dateObj.toLocaleString())
    }
  },
  importConfig:async function (params) {
    try {
    let success = await timerConfig.import()
    if (success) {
      self.refreshView("syncView")
      self.refreshView("configView")
      MNUtil.showHUD("Import Success!")
    }
    } catch (error) {
      timerUtils.addErrorLog(error, "importConfig")
    }
  },
  syncConfig: function (params) {
    let success = timerConfig.sync()
    if (success) {
      self.refreshView("syncView")
      MNUtil.showHUD("Sync Success!")
    }
  },
  focusConfigNoteId:function (params) {
  try {
    let syncNoteId = timerConfig.getConfig("syncNoteId")
        let note = MNNote.new(syncNoteId)
        if (note) {
          note.focusInFloatMindMap()
        }else{
          MNUtil.showHUD("Note not exist!")
        }
  } catch (error) {
    MNUtil.showHUD("Error in focusConfigNoteId: "+error)
  }
  },
  toggleAutoExport: function (params) {
  try {
    timerConfig.config.autoExport = !timerConfig.getConfig("autoExport")
    MNButton.setTitle(self.autoExportButton, "Auto Export: "+(timerConfig.getConfig("autoExport")?"✅":"❌"))
    timerConfig.save("MNTimer_config")
  } catch (error) {
    MNUtil.showHUD(error)
  }
  },
  toggleAutoImport: function (params) {
    timerConfig.config.autoImport = !timerConfig.getConfig("autoImport")
    MNButton.setTitle(self.autoImportButton, "Auto Import: "+(timerConfig.getConfig("autoImport")?"✅":"❌"))
    timerConfig.save("MNTimer_config")
  },
  pasteConfigNoteId:function (params) {
    let noteId = MNUtil.clipboardText
    let note = MNNote.new(noteId)//MNUtil.getNoteById(noteId)
    if (note) {
      self.configNoteIdInput.text = note.noteId
      timerConfig.config.syncNoteId = noteId.noteId
      timerConfig.save("MNTimer_config")
      MNUtil.showHUD("Save Config NoteId")
    }else{
      MNUtil.showHUD("Note not exist!")
    }
  },
  clearConfigNoteId:function (params) {
    self.configNoteIdInput.text = ""
    timerConfig.config.syncNoteId = ""
    timerConfig.save("MNTimer_config")
    MNUtil.showHUD("Clear Config NoteId")
  }
});

timerController.prototype.homePage = function() {
  if (!this.isFirst) {
    return
  }
  this.isFirst = false
    this.webview.loadFileURLAllowingReadAccessToURL(
      NSURL.fileURLWithPath(timerUtils.mainPath + '/timer.html'),
      NSURL.fileURLWithPath(timerUtils.mainPath + '/')
    );
};
timerController.prototype.clearContent = function() {
    // this.webview.loadHTMLStringBaseURL("");
    this.webview.removeFromSuperview();
};

/** @this {timerController} */
timerController.prototype.setToolbar = async function(state) {
  timerConfig.toolbar = state
  this.webAppButton.hidden = !timerConfig.toolbar
  this.homeButton.hidden = !timerConfig.toolbar
  this.goBackButton.hidden = !timerConfig.toolbar
  this.goForwardButton.hidden = !timerConfig.toolbar
  this.refreshButton.hidden = !timerConfig.toolbar
  // this.webAppEntriesButton.hidden = !timerConfig.toolbar
  // this.screenButton.hidden = !timerConfig.toolbar
  this.engineButton.hidden = !timerConfig.toolbar

}

/** @this {timerController} */
timerController.prototype.updateDeeplOffset = async function() {
  if(!this.webview || !this.webview.window)return;
  // if (Application.sharedInstance().osType !== 1) {
  await this.runJavaScript(getWebJS("updateDeeplOffset"))
  // } else {
  //   this.webview.evaluateJavaScript(
  //     `document.querySelector("#gatsby-focus-wrapper > header").style.display = "none";
  //      document.querySelector("#gatsby-focus-wrapper > footer").style.display = "none";
  //      document.getElementsByClassName("TranslatorPage-module--otherSections--3cbQ7")[0].style.display = "none";`,
  //     (ret) => {}
  //   );
  // }
  let ret = await this.runJavaScript('document.getElementsByClassName("lmt__side_container--target")[0].getBoundingClientRect().top + document.body.scrollTop+document.documentElement.scrollTop;')
  if (ret && !isNaN(parseFloat(ret))) {
    this.webview.scrollView.contentOffset = {x: 0, y: parseFloat(ret) + 0};          
  } else {
    this.webview.scrollView.contentOffset = {x: 0, y: 130};          
  }
  // this.shouldCopy = false
  // this.shouldComment = false
};
/** @this {timerController} */
timerController.prototype.updateBaiduOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("new-header")[0].style.display = "none";`)
  this.shouldCopy = false
  this.shouldComment = false
};

/** @this {timerController} */
timerController.prototype.updateBingOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementById("bnp_container").style.display = "none";`)
};

/** @this {timerController} */
timerController.prototype.updateYoudaoOffset = async function() {
  if(!this.webview || !this.webview.window)return;
  await this.runJavaScript(`document.getElementsByClassName("top-download")[0].style.display = "none";
    document.getElementsByClassName("m-top_vav")[0].style.display = "none";`)
  if (this.shouldCopy || this.shouldComment) {
    let result = await this.runJavaScript(`
    let containers = document.getElementsByClassName("trans-container")
    let explains = Array.from(document.getElementsByClassName("word-exp"))
    if (containers.length === 1) {
      containers[0].getElementsByClassName("trans-content")[0].textContent
    }else{
      explains.map(explain=>explain.textContent).join("\\n")
    }
    `)

    if (!timerUtils.isNSNull(result) && this.shouldCopy) {
      MNUtil.copy(result)
    }
    if (!timerUtils.isNSNull(result) && this.shouldComment) {
      MNUtil.undoGrouping(()=>{
        MNUtil.getNoteById(this.currentNoteId).appendTextComment(ret)
      })
    }
    this.shouldCopy = false
    this.shouldComment = false
  }
};
/** @this {timerController} */
timerController.prototype.updateRGOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("header")[0].style.display = "none"`)
  this.shouldCopy = false
  this.shouldComment = false
};

/** @this {timerController} */
timerController.prototype.runJavaScript = async function(script,delay) {
  if(!this.webview || !this.webview.window)return;
  return new Promise((resolve, reject) => {
    if (delay) {
      this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(delay, true, () => {
        this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
      })
    }else{
      this.webview.evaluateJavaScript(script,(result) => {resolve(result)});
    }
  })
};

/** @this {timerController} */
timerController.prototype.updateBilibiliOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementsByClassName("recommended-swipe grid-anchor")[0].style.display = "none";`,0.5)
};

/** @this {timerController} */
timerController.prototype.updateBilibiliPCOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.runJavaScript(`document.getElementById("biliMainHeader").style.display = "none";`,1)
  this.shouldCopy = false
  this.shouldComment = false
};

/** @this {timerController} */
timerController.prototype.updateThesaurusOffset = function() {
  if(!this.webview || !this.webview.window)return;
  this.viewTimer = NSTimer.scheduledTimerWithTimeInterval(2, true, () => {
    this.runJavaScript(getWebJS("updateThesaurusOffset"))
    this.viewTimer.invalidate();
  });
  this.shouldCopy = false
  this.shouldComment = false
};

/** @this {timerController} */
timerController.prototype.getCurrentURL = async function() {
  if(!this.webview || !this.webview.window) return;
  let url = await this.runJavaScript(`window.location.href`)
  this.webview.url = url
  return url
};
/** @this {timerController} */
timerController.prototype.getSelectedTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getCurrentSelect(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
      }
      return selectedText
    };
      getCurrentSelect()
    `)
  return ret
}

/** @this {timerController} */
timerController.prototype.getTextInWebview = async function() {
  let ret = await this.runJavaScript(`
      function getSelectOrWholeText(){

      let selectionObj = null, rangeObj = null;
      let selectedText = "", selectedHtml = "";

      if(window.getSelection){
        selectionObj = window.getSelection();
        selectedText = selectionObj.toString();
        return selectedText === ""?document.body.innerText:selectedText
      }else{
        return document.body.innerText;
      }
    };
    getSelectOrWholeText()
    // document.body.innerHTML;
    `)
  return ret
}

/** @this {timerController} */
timerController.prototype.changeButtonOpacity = function(opacity) {
    this.toolbar.layer.opacity = opacity
    this.moveButton.layer.opacity = opacity
    this.minButton.layer.opacity = opacity
    this.closeButton.layer.opacity = opacity
}

/** @this {timerController} */
timerController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
    button.layer.cornerRadius = 8;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}

/** @this {timerController} */
timerController.prototype.createButton = function (buttonName,targetAction,superview) {
    this[buttonName] = UIButton.buttonWithType(0);
    this[buttonName].autoresizingMask = (1 << 0 | 1 << 3);
    this[buttonName].setTitleColorForState(UIColor.whiteColor(),0);
    this[buttonName].setTitleColorForState(this.highlightColor, 1);
    this[buttonName].backgroundColor = MNUtil.hexColorAlpha("#a4a4a4",0.8)
    this[buttonName].layer.cornerRadius = 8;
    this[buttonName].layer.masksToBounds = true;
    this[buttonName].titleLabel.font = UIFont.systemFontOfSize(16);

    if (targetAction) {
      this[buttonName].addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    if (superview) {
      this[superview].addSubview(this[buttonName])
    }else{
      this.view.addSubview(this[buttonName]);
    }
}

/** @this {timerController} */
timerController.prototype.settingViewLayout = function (){
  try {
  

    let viewFrame = this.view.bounds
    let width = viewFrame.width
    let height = viewFrame.height
    this.settingView.frame = {x:1,y:20,width:width-2,height:height-50}
    this.configView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.advanceView.frame = MNUtil.genFrame(0,40,width-2,height-60)
    this.syncView.frame = MNUtil.genFrame(0,40,width-2,height-60)


    this.orderButton.frame = MNUtil.genFrame(10,20,width-20,35)
    this.setHomepageButton.frame = MNUtil.genFrame(10,60,width-20,35)
    this.setCustomButton1.frame = MNUtil.genFrame(10,100,width-20,35)
    this.setCustomButton2.frame = MNUtil.genFrame(10,140,width-20,35)
    this.setCustomButton3.frame = MNUtil.genFrame(10,180,width-20,35)
    this.timestampDetail.frame = MNUtil.genFrame(10,220,width-20,35)
    this.textviewInput.frame = {x:10,y:height-255,width:width-22,height:155}
    this.uploadButton.frame = {x:width-87,y:height-135,width:70,height:30}
    this.deleteButton.frame = {x:width-122,y:height-135,width:30,height:30}

    this.scrollview.frame = {x:10,y:50,width:width-22,height:height-310}
    this.scrollview.contentSize = {width:width-22,height:height};
    this.moveUpButton.frame = {x:width-47,y:height-365,width:30,height:30}
    this.moveDownButton.frame = {x:width-47,y:height-330,width:30,height:30}
    this.newEntryButton.frame = {x:width-47,y:height-295,width:30,height:30}

    this.configNoteIdInput.frame = MNUtil.genFrame(10,10,width-20,65)
    this.syncTimeButton.frame = MNUtil.genFrame(10,80,width-20,35)
    this.exportConfigButton.frame = MNUtil.genFrame(10,120,width-20,35)
    this.importConfigButton.frame = MNUtil.genFrame(10,160,width-20,35)
    this.autoExportButton.frame = MNUtil.genFrame(10,205,(width-25)*0.5,35)
    this.autoImportButton.frame = MNUtil.genFrame(15+(width-25)*0.5,205,(width-25)*0.5,35)
    this.pasteConfigNoteButton.frame = MNUtil.genFrame(width-75,40,60,30)
    this.clearConfigNoteButton.frame = MNUtil.genFrame(width-140,40,60,30)
    this.focusConfigNoteButton.frame = MNUtil.genFrame(width-205,40,60,30)

    let settingFrame = this.settingView.bounds
    settingFrame.x = 5
    settingFrame.y = 5
    settingFrame.height = 40
    settingFrame.width = settingFrame.width-10
    this.tabView.frame = settingFrame
    settingFrame.width = 80
    settingFrame.y = 10
    settingFrame.x = 10
    settingFrame.height = 30
    this.configButton.frame = settingFrame
    settingFrame.x = 160
    settingFrame.width = 90
    this.advancedButton.frame = settingFrame
    settingFrame.x = 95
    settingFrame.width = 60
    this.syncConfig.frame = settingFrame
    settingFrame.x = width - 45
    settingFrame.width = 30
    this.closeConfig.frame = settingFrame
    settingFrame.width = 80
    settingFrame.x = 10
    settingFrame.y = 15
    this.configSearch.frame = settingFrame
    settingFrame.x = 95
    this.configWebApp.frame = settingFrame
    settingFrame.x = width-92
    this.configReset.frame = settingFrame

  } catch (error) {
    timerUtils.addErrorLog(error, "settingViewLayout")
  }
}

/** @this {timerController} */
timerController.prototype.createSettingView = function (){
try {
  let targetView = "settingView"
  MNUtil.showHUD("createSettingView")

  this.configMode = 0
  this.configEngine = timerConfig.engine
  this.settingView = UIView.new()
  this.settingView.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0.8)
  this.settingView.layer.cornerRadius = 13
  this.settingView.hidden = true
  this.view.addSubview(this.settingView)
  this.tabView = UIView.new()
  this.tabView.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8)
  this.tabView.layer.cornerRadius = 12
  this.settingView.addSubview(this.tabView)

  this.configView = UIView.new()
  this.configView.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.0)
  this.configView.layer.cornerRadius = 12
  this.settingView.addSubview(this.configView)

  this.advanceView = UIView.new()
  this.advanceView.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.0)
  this.advanceView.layer.cornerRadius = 12
  this.settingView.addSubview(this.advanceView)
  this.advanceView.hidden = true

  this.syncView = UIView.new()
  this.syncView.backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.0)
  this.syncView.layer.cornerRadius = 12
  this.settingView.addSubview(this.syncView)
  this.syncView.hidden = true

  // this.creatView("syncView",targetView,"#9bb2d6",0.0)
  // this.syncView.hidden = true

  this.createButton("configButton","configButtonTapped:",targetView)
  this.configButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.configButton.layer.opacity = 1.0
  // this.configButton.setTitleForState("Config",0)
  MNButton.setConfig(this.configButton, {title:"Config",font:17,bold:true})

  this.createButton("advancedButton","advancedButtonTapped:",targetView)
  // this.advancedButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.advancedButton.layer.opacity = 1.0
  this.advancedButton.setTitleForState("Advanced",0)
  MNButton.setConfig(this.advancedButton, {title:"Advanced",font:17,bold:true})

  this.createButton("closeConfig","closeConfigTapped:",targetView)
  this.closeConfig.setImageForState(timerUtils.stopImage,0)
  this.closeConfig.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)

  this.createButton("syncConfig","syncConfigTapped:",targetView)
  MNButton.setConfig(this.syncConfig, 
    {color:"#9bb2d6",alpha:0.8,opacity:1.0,title:"Sync",font:17,bold:true}
  )

  targetView = "configView"

  this.createButton("configSearch","configSearchTapped:",targetView)
  this.configSearch.layer.opacity = 1.0
  this.configSearch.setTitleForState("Search",0)
  this.configSearch.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)

  this.createButton("configWebApp","configWebAppTapped:",targetView)
  this.configWebApp.layer.opacity = 1.0
  this.configWebApp.setTitleForState("WebApp",0)

  this.createButton("configReset","resetConfig:",targetView)
  this.configReset.layer.opacity = 1.0
  this.configReset.setTitleForState("Reset",0)



  this.scrollview = UIScrollView.new()
  let viewFrame = this.view.bounds;
  this.configView.addSubview(this.scrollview)
  this.scrollview.hidden = false
  this.scrollview.delegate = this
  this.scrollview.bounces = true
  this.scrollview.alwaysBounceVertical = true
  this.scrollview.layer.cornerRadius = 8
  this.scrollview.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
  this.textviewInput = UITextView.new()
  this.textviewInput.font = UIFont.systemFontOfSize(16);
  this.textviewInput.layer.cornerRadius = 8
  this.textviewInput.backgroundColor = MNUtil.hexColorAlpha("#c0bfbf",0.8)
  this.textviewInput.textColor = UIColor.blackColor()
  this.configView.addSubview(this.textviewInput)
  this.textviewInput.text = `Input here`
  this.textviewInput.bounces = true

  // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNTimer_entries');
  this.createButton("uploadButton","configSaveTapped:",targetView)
  this.uploadButton.layer.opacity = 1.0
  MNButton.setColor(this.uploadButton, "#e06c75")
  MNButton.setTitle(this.uploadButton, "Save",undefined,true)
  
  this.createButton("deleteButton","configDeleteTapped:",targetView)
  this.deleteButton.layer.opacity = 1.0
  this.deleteButton.setTitleForState("🗑",0)
  MNButton.setColor(this.deleteButton, "#ffffff",0.8)

  this.createButton("moveUpButton","configMoveUpTapped:",targetView)
  this.moveUpButton.layer.opacity = 1.0
  this.moveUpButton.setTitleForState("🔼",0)
  MNButton.setColor(this.moveUpButton, "#ffffff",0.8)
  this.createButton("moveDownButton","configMoveDownTapped:",targetView)
  this.moveDownButton.layer.opacity = 1.0
  this.moveDownButton.setTitleForState("🔽",0)
  MNButton.setColor(this.moveDownButton, "#ffffff",0.8)

  this.createButton("newEntryButton","configAddTapped:",targetView)
  this.newEntryButton.layer.opacity = 1.0
  this.newEntryButton.setTitleForState("➕",0)
  MNButton.setColor(this.newEntryButton, "#ffffff",0.8)
  
  this.createButton("orderButton","changeSearchOrder:","advanceView")
  this.orderButton.layer.opacity = 1.0
  this.orderButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.orderButton.setTitleForState(timerUtils.getOrderText(timerConfig.searchOrder),0)

  this.createButton("setHomepageButton","setHomepage:","advanceView")
  this.setHomepageButton.layer.opacity = 1.0
  this.setHomepageButton.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.setHomepageButton.setTitleForState("HomePage: "+timerConfig.getConfig("homePage").url,0)

  this.createButton("setCustomButton1","changeCustomButton:","advanceView")
  this.setCustomButton1.index = 1
  this.setCustomButton1.layer.opacity = 1.0
  this.setCustomButton1.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.setCustomButton1.setTitleForState("Custom1: "+timerConfig.getConfig("custom"),0)

  this.createButton("setCustomButton2","changeCustomButton:","advanceView")
  this.setCustomButton2.index = 2
  this.setCustomButton2.layer.opacity = 1.0
  this.setCustomButton2.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.setCustomButton2.setTitleForState("Custom2: "+timerConfig.getConfig("custom2"),0)

  this.createButton("setCustomButton3","changeCustomButton:","advanceView")
  this.setCustomButton3.index = 3
  this.setCustomButton3.layer.opacity = 1.0
  this.setCustomButton3.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.setCustomButton3.setTitleForState("Custom3: "+timerConfig.getConfig("custom3"),0)

  this.createButton("timestampDetail","toggleTimestampeDetail:","advanceView")
  this.timestampDetail.layer.opacity = 1.0
  this.timestampDetail.backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
  this.timestampDetail.setTitleForState("Timestamp Detail: "+(timerConfig.getConfig("timestampDetail")?"✅":"❌"),0)
  targetView = "syncView"

  this.creatTextView("configNoteIdInput",targetView)
  this.configNoteIdInput.editable = false

  this.createButton("syncTimeButton","syncConfig:",targetView)
  MNButton.setConfig(this.syncTimeButton, {color:"#457bd3",alpha:0.8})
  
  this.createButton("exportConfigButton","exportConfig:",targetView)
  MNButton.setConfig(this.exportConfigButton, {title:"Export Config To Note",color:"#457bd3",alpha:0.8})

  this.createButton("importConfigButton","importConfig:",targetView)
  MNButton.setConfig(this.importConfigButton, {title:"Import Config From Note",color:"#457bd3",alpha:0.8})

  this.createButton("autoExportButton","toggleAutoExport:",targetView)
  MNButton.setConfig(this.autoExportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("autoImportButton","toggleAutoImport:",targetView)
  MNButton.setConfig(this.autoImportButton, {color:"#457bd3",alpha:0.8})

  this.createButton("pasteConfigNoteButton","pasteConfigNoteId:",targetView)
  MNButton.setConfig(this.pasteConfigNoteButton, {title:"Paste",color:"#9bb2d6",alpha:0.8})

  this.createButton("clearConfigNoteButton","clearConfigNoteId:",targetView)
  MNButton.setConfig(this.clearConfigNoteButton, {title:"Clear",color:"#9bb2d6",alpha:0.8})

  this.createButton("focusConfigNoteButton","focusConfigNoteId:",targetView)
  MNButton.setConfig(this.focusConfigNoteButton, {title:"Focus",color:"#9bb2d6",alpha:0.8})
  this.refreshView(targetView)
} catch (error) {
  timerUtils.addErrorLog(error, "createSettingView")
}
try {
  let text  = timerConfig.entries[timerConfig.engine]
  if (!text.title) {
    if (timerConfig.engine in timerConfig.defaultEntries) {
      text = timerConfig.defaultEntries[timerConfig.engine]
      timerConfig.entries[timerConfig.engine] = text
    }else{
      timerConfig.engine = timerConfig.entrieNames[0]
      text  = timerConfig.entries[timerConfig.engine]
    }
  }
  this.textviewInput.text = `{
  "title":   "${text.title}",
  "symbol":  "${text.symbol}",
  "engine":  "${text.engine}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
} catch (error) {
    timerUtils.addErrorLog(error, "textviewInput")
}

}

/** @this {timerController} */
timerController.prototype.setButtonText = function (names,highlight) {
try {

    this.words = names

    names.map((word,index)=>{
      if (!this["nameButton"+index]) {
        this.createButton("nameButton"+index,"toggleSelected:","scrollview")
        // this["nameButton"+index].index = index
        this["nameButton"+index].titleLabel.font = UIFont.systemFontOfSize(16);
      }
      this["nameButton"+index].hidden = false
      this["nameButton"+index].setTitleForState(this.configMode===0?timerConfig.entries[word].title:timerConfig.webAppEntries[word].title,0) 
      this["nameButton"+index].id = word

      if (word === highlight) {
        this["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#457bd3",0.8)
      }else{
        this["nameButton"+index].backgroundColor = MNUtil.hexColorAlpha("#9bb2d6",0.8);
      }
      // this["nameButton"+index].titleEdgeInsets = {top:0,left:-100,bottom:0,right:-50}
      // this["nameButton"+index].setTitleForState(this.imagePattern[index]===this.textPattern[index]?` ${this.imagePattern[index]} `:"-1",0) 
    })
    // this.refreshLayout()
} catch (error) {
    timerUtils.addErrorLog(error, "setButtonText")
}
}
/** @this {timerController} */
timerController.prototype.setTextview = function (name) {
    if (this.configMode === 0) {
      // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNTimer_entries');
      let text  = timerConfig.entries[name]
      this.textviewInput.text = `{
  "title":   "${text.title}",
  "symbol":  "${text.symbol}",
  "engine":  "${text.engine}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
    }else{
      // let entries           = NSUserDefaults.standardUserDefaults().objectForKey('MNTimer_webAppEntries');
      let text  = timerConfig.webAppEntries[name]
      this.textviewInput.text = `{
  "title":   "${text.title}",
  "desktop": ${text.desktop},
  "link":    "${text.link}"
}`
    }

}
/** @this {timerController} */
timerController.prototype.setSplitScreenFrame = function (mode) {  
  let studyFrame = MNUtil.studyView.bounds
  let height = studyFrame.height;
  let width = studyFrame.width;
  let splitLine = MNUtil.splitLine ?? width/2.
  let targetFrame
  switch (mode) {
  case "left":
    this.view.frame = MNUtil.genFrame(40,0,splitLine-40,height)
    break;
  case "left13":
    this.view.frame = MNUtil.genFrame(40,0,width/3.+40,height)
    break;
  case "right":
    this.view.frame = MNUtil.genFrame(splitLine,0,width-splitLine-40,height)
    break;
  case "right13":
    this.view.frame = MNUtil.genFrame(width*2/3.-40,0,width/3.,height)
    break;
  case "full":
    this.view.frame = MNUtil.genFrame(40,0,width-80,height)
    break;
  default:
    break;
  }
  this.currentFrame = this.view.frame
}
/** @this {timerController} */
timerController.prototype.toMinimode = function (frame) {
  this.miniMode = true 
  this.hasTodoText = this.todoText.text.trim() !== ""
  timerConfig.dynamic = false    
  this.lastFrame = this.view.frame 
  this.webview.hidden = false
  // this.webview.frame = MNUtil.genFrame(0, 0, this.view.frame.width, this.view.frame.height)
  this.currentFrame  = this.view.frame
  this.onAnimate = true
  if (frame.x < 0) {
    frame.x = 0
  }
  if (frame.x >= (MNUtil.currentWindow.frame.width-200)) {
    frame.x = MNUtil.currentWindow.frame.width-200
  }
  if (this.hasTodoText) {
    frame.height = 110
  }
  let viewFrame = MNUtil.genFrame(0, 0, frame.width, 70)
  MNButton.setColor(this.moveButton,"#a4a4a4",0.0)
  this.hideAllButton()
  MNUtil.animate(()=>{
    this.setFrame(frame)
    this.moveButton.frame = viewFrame
    this.webview.frame = viewFrame
    this.todoText.hidden = !this.hasTodoText
    this.todoText.frame = MNUtil.genFrame(0,viewFrame.height+5,viewFrame.width,35)
    this.todoText.endEditing(true)
    MNButton.setRadius(this.view,10)
    MNButton.setRadius(this.webview,10)
  }).then(()=>{
    this.moveButton.hidden = false
    this.onAnimate = false
    this.webview.endEditing(true)
  })
}
/** @this {timerController} */
timerController.prototype.refreshLayout = function () {
  if (this.settingView.hidden) {
    let preOpacity = this.settingView.layer.opacity
    this.settingView.layer.opacity = 0.2
    // this.settingView.hidden = false
    this.settingView.layer.opacity = preOpacity
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.configMode===0?timerConfig.entries[word].title:timerConfig.webAppEntries[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        MNUtil.showHUD("index:"+index)
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  }else{
    var viewFrame = this.scrollview.bounds;
    var xLeft     = 0
    let initX = 10
    let initY = 10
    let initL = 0
    this.locs = [];
    this.words.map((word,index)=>{
      let title = this.configMode===0?timerConfig.entries[word].title:timerConfig.webAppEntries[word].title
      let width = strCode(title.replaceAll(" ",""))*9+15
      if (xLeft+initX+width > viewFrame.width-10) {
        initX = 10
        initY = initY+40
        initL = initL+1
      }
      this["nameButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: width,  height: 30,};
      this.locs.push({
        x:xLeft+initX,
        y:initY,
        l:initL,
        i:index
      })
      initX = initX+width+10
    })
    if (this.lastLength && this.lastLength>this.words.length) {
      for (let index = this.words.length; index < this.lastLength; index++) {
        this["nameButton"+index].hidden = true
      }
    }
    this.lastLength = this.words.length
    this.scrollview.contentSize= {width:viewFrame.width,height:initY+40}
  
  }


}
/** @this {timerController} */
timerController.prototype.hideAllButton = function (frame) {
  this.moveButton.hidden = true
  this.closeButton.hidden = true
  this.screenButton.hidden = true
  this.minButton.hidden = true
}
/** @this {timerController} */
timerController.prototype.showAllButton = function (frame) {
  this.moveButton.hidden = false
  this.closeButton.hidden = false
  this.minButton.hidden = false
  this.screenButton.hidden = false
}
/** @this {timerController} */
timerController.prototype.show = function (beginFrame,endFrame) {
  let preFrame = this.view.frame
  let studyFrame = MNUtil.studyView.frame
  if (endFrame) {
    preFrame = endFrame
  }
  if (preFrame.width > studyFrame.width) {
    preFrame.width = studyFrame.width
  }
  let width = preFrame.width
  let height = preFrame.height
  let preOpacity = this.view.layer.opacity
  // studyController().view.bringSubviewToFront(this.view)
  this.view.layer.opacity = 0.2
  if (beginFrame) {
    this.setFrame(beginFrame)
  }
  this.view.hidden = false
  this.miniMode = false
  if (!this.webview.isDescendantOfView(this.view)) {
    this.view.addSubview(this.webview)
    this.view.bringSubviewToFront(this.moveButton)
    this.view.bringSubviewToFront(this.closeButton)
    this.view.bringSubviewToFront(this.screenButton)
    this.view.bringSubviewToFront(this.minButton)
    this.view.bringSubviewToFront(this.todoText)
    this.webview.frame = {x:0,y:8,width:this.view.frame.width,height:this.view.frame.height-8}
    this.todoText.frame = MNUtil.genFrame(this.view.frame.width*0.5-100,this.view.frame.height-40,200,35)
  }
  this.webview.hidden = false
  this.hideAllButton()
  this.onAnimate = true
  this.timerOn = true

  if (timerConfig.toolbar) {
    this.engineButton.hidden = false
  }
  MNButton.setColor(this.moveButton,"#a4a4a4",0.8)
  MNUtil.animate(()=>{
    this.view.layer.opacity = preOpacity
    this.setFrame(preFrame)
    this.webview.frame = {x:0,y:8,width:width,height:height-8}
    this.todoText.frame = MNUtil.genFrame(width*0.5-100,height-40,200,35)
    this.todoText.hidden = false
    MNButton.setRadius(this.view,15)
    MNButton.setRadius(this.webview,15)
    // if (width>300) {
    //   this.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: 150,  height: 15};
    // }else{
    //   this.moveButton.frame = {  x: width*0.5-75,  y: 0,  width: width*0.35,  height: 15};
    // }
  }).then(()=>{
    MNUtil.studyView.bringSubviewToFront(this.view)
    this.webview.layer.borderWidth = 0
    this.view.layer.borderWidth = 0
    this.webview.hidden = false
    this.onAnimate = false
    this.view.setNeedsLayout()
    this.showAllButton()
    this.webview.endEditing(true)
  })
}
/** @this {timerController} */
timerController.prototype.hide = async function (frame) {
  return new Promise((resolve, reject) => {
    let preFrame = this.view.frame
    let preOpacity = this.view.layer.opacity
    let preCustom = this.custom
    // let preFrame = this.view.frame
    this.webview.hidden = false
    if (this.settingView) {
      this.settingView.hidden = true
    }
    this.hideAllButton()
    this.custom = false
    this.onAnimate = true
    this.timerOn = false
    MNUtil.animate(()=>{
      this.view.layer.opacity = 0.2
      // if (frame) {
      //   this.setFrame(frame)
      // }
    }).then(()=>{
      this.view.hidden = true;
      this.view.layer.opacity = preOpacity      
      this.setFrame(preFrame)
      this.webview.layer.borderWidth = 0
      this.onAnimate = false
      this.custom = preCustom
      this.webview.endEditing(true)
      resolve()
    })
  })

}
/** @this {timerController} */
timerController.prototype.setFrame = function(x,y,width,height){
    if (typeof x === "object") {
      this.view.frame = x
    }else{
      this.view.frame = MNUtil.genFrame(x, y, width, height)
    }
    this.currentFrame = this.view.frame
  }

/** @this {timerController} */
timerController.prototype.creatView = function (viewName,superview="view",color="#9bb2d6",alpha=0.8) {
  this[viewName] = UIView.new()
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].layer.cornerRadius = 12
  this[superview].addSubview(this[viewName])
}

/** @this {timerController} */
timerController.prototype.creatTextView = function (viewName,superview="view",color="#c0bfbf",alpha=0.8) {
  this[viewName] = UITextView.new()
  this[viewName].font = UIFont.systemFontOfSize(15);
  this[viewName].layer.cornerRadius = 8
  this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
  this[viewName].textColor = UIColor.blackColor()
  this[viewName].delegate = this
  this[viewName].bounces = true
  this[superview].addSubview(this[viewName])
}

timerController.prototype.refreshView = function (targetView) {
  switch (targetView) {
    case "syncView":
      break;
    case "configView":
      if (this.configMode === 0) {
        this.setButtonText(timerConfig.entrieNames,timerConfig.engine)
        this.setTextview(timerConfig.engine)
      }else{
        this.setButtonText(timerConfig.webAppEntrieNames,this.webApp)
        this.setTextview(this.webApp)
      }
      break;
    default:
      break;
  }

}
timerController.prototype.getCurrentURL = async function(url) {
  return new Promise((resolve, reject) => {
    if(!this.webview || !this.webview.window)return;
    this.webview.evaluateJavaScript(
      `window.location.href`,
      (ret) => {
        this.webview.url = ret
        resolve(ret)
      }
    );
  })
};
/** @this {timerController} */
timerController.prototype.openOrJump = async function(bvid,time,p) {
try {
  

  if (this.view.hidden) {
    MNUtil.showHUD(`window is hidden`)
    return
  }
  let timestamp = await this.getTimestamp()

  // await this.getCurrentURL()

  // let res = this.webview.url.match(/(?<=bilibili.com\/video\/)\w+/);
  // // MNUtil.copy("bv:"+this.webview.url)
  // if (res) {
  //   this.currentBvid = res[0]
  // }else{
  //   this.currentBvid = ""
  // }
  let formatedVideoTime = timerUtils.formatSeconds(parseFloat(time))

  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
    // MNUtil.copyJSON([this.currentP,p])
  if (this.currentBvid && this.currentBvid === bvid && (this.currentP === p)) {
    MNUtil.showHUD(`Jump to ${formatedVideoTime}`)
    this.runJavaScript(`document.getElementsByTagName("video")[0].currentTime = ${time}`)
  }else{
    //  Application.sharedInstance().showHUD("should open", this.view.window, 2);
    this.currentBvid = bvid
    var url = `https://www.bilibili.com/`+bvid+`?t=`+time
    if (p) {
      url = url+"&p="+p
    }
    MNUtil.showHUD(url)
    this.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    this.runJavaScript(`window.location.href="${url}"`)
    // MNConnection.loadRequest(this.webview, url)
  }
} catch (error) {
  timerUtils.addErrorLog(error, "openOrJump")
}
};
/** @this {timerController} */
timerController.prototype.openOrJumpForYT = async function(Ytid,time) {
try {
  let parseTime = parseInt(time)
  if (this.view.hidden) {
     Application.sharedInstance().showHUD(`window is hidden`, this.view.window, 2);
    return
  }
  await this.getCurrentURL()
  let res = this.webview.url.match(/(?<=youtube.com\/watch\?t\=.*&v\=)\w+/);
  if (res) {
    this.currentYtid = res[0]
  }else{
    this.currentYtid = ""
  }
  let formatedVideoTime = timerUtils.formatSeconds(parseTime)
  // NSUserDefaults.standardUserDefaults().synchronize();
  // let object = NSUserDefaults.standardUserDefaults().objectForKey("UserAgent");
    //  Application.sharedInstance().showHUD(text, this.view.window, 2);
  if (this.currentYtid && this.currentYtid === Ytid) {
    MNUtil.showHUD(`Jump to ${formatedVideoTime}`)
    this.runJavaScript(`document.getElementsByTagName("video")[0].currentTime = ${parseTime}`)
  }else{
    //  Application.sharedInstance().showHUD("should open", this.view.window, 2);
    this.currentYtid = Ytid
    var url = `https://youtu.be/`+Ytid+`?t=`+parseTime
    MNUtil.showHUD(url)
    // MNUtil.copy(url)
    // this.webview.customUserAgent = 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_15_6) AppleWebKit/605.1.15 (KHTML, like Gecko) Version/16.0 Safari/605.1.15'
    MNConnection.loadRequest(this.webview, url)
  }
} catch (error) {
  timerUtils.addErrorLog(error, "openOrJump")
}
};
/** @this {timerController} */
timerController.prototype.getTimestamp = async function(){
  let videoTime = await this.runJavaScript(`document.getElementsByTagName('video')[0].currentTime.toFixed(2);`)
  if (videoTime) {
    let url = await this.runJavaScript(`window.location.href`)
    let res = url.match(/(?<=bilibili.com\/video\/)\w+/);
    if (res) {
      let timestamp = {time:parseFloat(videoTime),bv:res[0]}
      this.currentBvid = timestamp.bv
      let testP = url.match(/(?<=bilibili.com\/video\/.+(\?|&)p\=)\d+/);
      if (testP) {
        timestamp.p = parseInt(testP[0])
        this.currentP = timestamp.p
      }else{
        this.currentP = 0
      }
      // https://www.bilibili.com/video/BV1F34y1h7so/?p=4
      // https://www.bilibili.com/video/BV1F34y1h7so?p=4
      return timestamp
    }
    this.currentBvid = ""
    this.currentP = 0
    return {time:parseFloat(videoTime)}
  }
  return undefined
}
/** @this {timerController} */
timerController.prototype.getVideoFrameInfo = async function(){
try {
    let imageBase64 = await this.runJavaScript(`
function getImage() {
// try {
  const video = document.getElementsByTagName('video')[0];
  video.crossOrigin = "anonymous"; // 尝试设置crossOrigin属性
  const canvas = document.createElement('canvas');
  const context = canvas.getContext('2d');
  canvas.width = video.videoWidth*2;
  canvas.height = video.videoHeight*2;
  context.drawImage(video, 0, 0, canvas.width, canvas.height);
  return canvas.toDataURL('image/png');
// } catch (error) {
//   return error.toString()
// }
};
getImage();
`)
    if (timerUtils.isNSNull(imageBase64)) {
      let image = await this.screenshot(this.view.frame.width>1000?this.view.frame.width:1000)
      if (!image) {
        MNUtil.showHUD("Capture video frame failed!")
        return undefined
      }
      imageBase64 = 'data:image/png;base64,'+image.base64Encoding()
    }
    // let videoTime = await this.runJavaScript(`document.getElementsByTagName('video')[0].currentTime.toFixed(2);`)
    let timestamp = await this.getTimestamp(this.webview.url)
    if (timestamp) {
      timestamp.image = imageBase64
    }
    return timestamp


    let res = this.webview.url.match(/(?<=bilibili.com\/video\/)\w+/);
    if (res) {
    // https://www.bilibili.com/video/BV1F34y1h7so?p=2
      let testP = this.webview.url.match(/(?<=bilibili.com\/video\/\w+\?p\=)\d+/);
      // MNUtil.copyJSON(testP)
      if (testP) {
        return {
          image:imageBase64,
          time:parseFloat(videoTime),
          bv:res[0],
          p:testP[0]
        }
      }
      return {
        image:imageBase64,
        time:parseFloat(videoTime),
        bv:res[0]
      }
    }else{
      res = this.webview.url.match(/(?<=youtube.com\/watch\?v\=)\w+/);
      if (res) {
        return {
          image:imageBase64,
          time:parseFloat(videoTime),
          yt:res[0]
        }
      }
      res = this.webview.url.match(/(?<=youtube.com\/watch\?t\=.*&v\=)\w+/);
      if (res) {
        return {
          image:imageBase64,
          time:parseFloat(videoTime),
          yt:res[0]
        }
      }
    }
    return {
      image:imageBase64,
      time:parseFloat(videoTime)
    }
} catch (error) {
  timerUtils.addErrorLog(error, "getVideoFrameInfo")
  return undefined
}
}
/**
 * 
 * @param {*} width 
 * @returns {Promise<NSData>}
 */
timerController.prototype.screenshot = async function(width){
  return new Promise((resolve, reject) => {
    this.webview.takeSnapshotWithWidth(width,(snapshot)=>{
      resolve(snapshot.pngData())
    })
  })
}

timerController.prototype.videoFrameAction= async function(target){
    if (!timerUtils.checkSubscribe(true)) {
      return
    }
    let videoFrameInfo= await self.getVideoFrameInfo()
    if (!videoFrameInfo) {
      return
    }
    let focusNote = MNNote.getFocusNote()
try {
  
    switch (target) {
      case "clipboard":
        if ("image" in videoFrameInfo) {
          let imageData = NSData.dataWithContentsOfURL(MNUtil.genNSURL(videoFrameInfo.image))
          MNUtil.copyImage(imageData)
          MNUtil.showHUD('视频截图已复制到剪贴板')
        }
        break;
      case "editor":
        if ("bv" in videoFrameInfo) {
          MNUtil.showHUD("videoframe → Editor")
          let formatedVideoTime = timerUtils.formatSeconds(videoFrameInfo.time)
          if ("p" in videoFrameInfo && videoFrameInfo.p) {
            MNUtil.postNotification("editorInsert", {contents:[
              {type:"image",content:videoFrameInfo.image},
              {type:"text",content:`[\[${formatedVideoTime}\] (${videoFrameInfo.bv}-${videoFrameInfo.p})](marginnote4app://addon/BilibiliExcerpt?videoId=${videoFrameInfo.bv}&t=${videoFrameInfo.time}&p=${videoFrameInfo.p})`}
            ]})
            break;
          }
          MNUtil.postNotification("editorInsert", {contents:[
            {type:"image",content:videoFrameInfo.image},
            {type:"text",content:`[\[${formatedVideoTime}\] (${videoFrameInfo.bv})](marginnote4app://addon/BilibiliExcerpt?videoId=${videoFrameInfo.bv}&t=${videoFrameInfo.time})`}
          ]})
        }
        break;
      case "excerpt":
        if (!focusNote) {
          MNUtil.showHUD("No note selected!")
          return
        }
        if ("bv" in videoFrameInfo) {
          MNUtil.showHUD("videoframe → Excerpt")
          if (focusNote.excerptPic && !focusNote.textFirst) {
            self.webview.endEditing(true)
            MNUtil.excuteCommand("EditTextMode")
          }
          let MDVideoInfo = timerUtils.videoInfo2MD(videoFrameInfo)
          let excerptText = (focusNote.excerptText??"")+`\n`+MDVideoInfo
            MNUtil.undoGrouping(()=>{
              focusNote.excerptText = excerptText
              focusNote.excerptTextMarkdown = true
              focusNote.processMarkdownBase64Images()
            })
        }
        break;
      case "childNote":
        if (!focusNote) {
          MNUtil.showHUD("No note selected!")
          return
        }
        if ("bv" in videoFrameInfo) {
          MNUtil.showHUD("videoframe → ChildNote")
          let MDVideoInfo = timerUtils.videoInfo2MD(videoFrameInfo)
          let config = {excerptText:MDVideoInfo,excerptTextMarkdown:true}
          let childNote = focusNote.createChildNote(config)
          childNote.focusInMindMap(0.5)
        }
        break;
      case "comment":
        if (!focusNote) {
          MNUtil.showHUD("No note selected!")
          return
        }
        if ("bv" in videoFrameInfo) {
          MNUtil.showHUD("videoframe → Comment")
          let MDVideoInfo = timerUtils.videoInfo2MD(videoFrameInfo)
            MNUtil.undoGrouping(()=>{
              focusNote.excerptTextMarkdown = true
              focusNote.appendMarkdownComment(MDVideoInfo)
              focusNote.processMarkdownBase64Images()
            })
        }
        break;
      case "newNote":
        if ("bv" in videoFrameInfo) {
          MNUtil.showHUD("videoframe → ChildNote")
          let MDVideoInfo = timerUtils.videoInfo2MD(videoFrameInfo)
          let config = {excerptText:MDVideoInfo,excerptTextMarkdown:true}
          let mindmap = MNUtil.mindmapView.mindmapNodes[0].note.childMindMap
          // MNNote.new(mindmap).focusInMindMap()
          if (mindmap) {
            let childNote = MNNote.new(mindmap).createChildNote(config)
            childNote.focusInMindMap(0.5)
          }else{
            MNUtil.showHUD("Create in main mindmap")
            MNUtil.undoGrouping(()=>{
              let newNote = MNNote.new(config)
              newNote.focusInMindMap(0.5)
            })
          }
        }
        break;
      default:
        MNUtil.showHUD("Unsupported action: "+target)
        break;
    }
  } catch (error) {
  timerUtils.addErrorLog(error, "videoFrameAction",target)
}
  }

timerController.prototype.animateTo = function(frame){
  this.onAnimate = true
  MNUtil.animate(()=>{
    this.view.frame = frame
    this.currentFrame = frame
  }).then(()=>{
    this.onAnimate = false
  })
}
timerController.prototype.checkPopover = function(){
  if (this.view.popoverController) {this.view.popoverController.dismissPopoverAnimated(true);}
}

timerController.prototype.pause = function () {
  MNUtil.showHUD("Toogle Pause")
  this.runJavaScript("togglePause()")
}
timerController.prototype.beginTimer = function (params) {
  
}
// timerController.prototype.creatTextView = function (viewName,superview="view",color="#c0bfbf",alpha=0.8) {
//   this[viewName] = UITextView.new()
//   this[viewName].font = UIFont.systemFontOfSize(15);
//   this[viewName].layer.cornerRadius = 8
//   this[viewName].backgroundColor = MNUtil.hexColorAlpha(color,alpha)
//   this[viewName].textColor = UIColor.blackColor()
//   this[viewName].delegate = this
//   this[viewName].bounces = true
//   this[superview].addSubview(this[viewName])
// }